/**
 ******************************************************************************
 * @file           : main.c
 * @author         : Auto-generated by STM32CubeIDE
 * @brief          : Main program body
 ******************************************************************************
 * @attention
 *
 * Copyright (c) 2022 STMicroelectronics.
 * All rights reserved.
 *
 * This software is licensed under terms that can be found in the LICENSE file
 * in the root directory of this software component.
 * If no LICENSE file comes with this software, it is provided AS-IS.
 *
 ******************************************************************************
 */

#include <stdint.h>

#if !defined(__SOFT_FP__) && defined(__ARM_FP)
  #warning "FPU is not initialized, but the project is compiling for an FPU. Please initialize the FPU before use."
#endif

/* Register Addresses*/

/* Clock */
#define RCC_BASE        0x40023800UL
#define RCC_AHB1ENR     RCC_BASE + 0x30


/* GPIO */
#define GPIOA_BASE      0x40020000UL
#define GPIOA_MODER     GPIOA_BASE + 0x00
#define GPIOA_BSRR      GPIOA_BASE + 0x18

/* delay counter */
#define DELAY_MAX       50000

int main(void)
{
  /* turn on clock on GPIOA */
  *(uint32_t *)(RCC_AHB1ENR) |= (1 << 0);

  /* set PA5 to output mode */
  *(uint32_t *)(GPIOA_MODER)  &= ~(1 << 11);
  *(uint32_t *)(GPIOA_MODER)  |=  (1 << 10);

  while(1) {
    /* set HIGH value on pin PA5 */
    *(uint32_t *)(GPIOA_BSRR)   |=  (1 <<  5);
    for(uint32_t i=DELAY_MAX; i--;);

    /* set LOW value on pin PA5 */
    *(uint32_t *)(GPIOA_BSRR)   |=  (1 << (5+16));
    for(uint32_t i=DELAY_MAX; i--;);
  }
}
